/[MITgcm]/MITgcm/verification/testreport
ViewVC logotype

Diff of /MITgcm/verification/testreport

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.103 by jmc, Fri Sep 21 19:23:33 2007 UTC revision 1.132 by jmc, Thu Jan 14 23:17:42 2010 UTC
# Line 11  usage() Line 11  usage()
11      echo      echo
12      echo "where possible OPTIONS are:"      echo "where possible OPTIONS are:"
13      echo "  (-help|-h)               print usage"      echo "  (-help|-h)               print usage"
14      echo "  (-mth)                   run multi threaded (using eedata.mth)"      echo "  (-mth)                   run multi-threaded (using eedata.mth)"
15      echo "  (-mpi)                   compile and run using MPI"      echo "  (-mpi)                   compile and run using MPI"
16      echo "  (-ieee|-noieee)          if possible, use IEEE compiler flags"      echo "  (-ieee|-noieee)          if possible, use IEEE compiler flags"
17      echo "                             (DEF=\"-ieee\")"      echo "                             (DEF=\"-ieee\")"
18        echo "  (-gsl)                   compile with \"-gsl\" flag"
19      echo "  (-of=|-optfile=)STRING   list of optfiles to use"      echo "  (-of=|-optfile=)STRING   list of optfiles to use"
20      echo "  (-a|-addr) STRING        list of email recipients"      echo "  (-a|-addr) STRING        list of email recipients"
21      echo "                             (DEF=\"edhill@mitgcm.org\")"      echo "                             (DEF=\"\" no email is sent)"
22        echo "  (-mpd|-mpackdir) DIR     location of the mpack utility"
23        echo "                             (DEF=\"../tools/mpack-1.6\")"
24      echo "  (-t|-tdir) STRING        list of group and/or exp. dirs to test"      echo "  (-t|-tdir) STRING        list of group and/or exp. dirs to test"
25      echo "                             (recognized groups: basic, tutorials)"      echo "                             (recognized groups: basic, tutorials)"
26      echo "                             (DEF=\"\" which test all)"      echo "                             (DEF=\"\" which test all)"
# Line 27  usage() Line 30  usage()
30      echo "                             Bourne-compatible \"sh\" shell"      echo "                             Bourne-compatible \"sh\" shell"
31      echo "                             (DEF=\"\" for \"bash\")"      echo "                             (DEF=\"\" for \"bash\")"
32      echo "  (-adm|-ad)               perform an adjoint run"      echo "  (-adm|-ad)               perform an adjoint run"
33        echo "  (-oad)                   perform an OpenAD adjoint run"
34      echo "  (-command) STRING        command to run"      echo "  (-command) STRING        command to run"
35      echo "                             (DEF=\"make output.txt\")"      echo "                             (DEF=\"make output.txt\")"
36      echo "  (-m|-make) STRING        command to use for \"make\""      echo "  (-m|-make) STRING        command to use for \"make\""
# Line 64  usage() Line 68  usage()
68  build_mpack()  build_mpack()
69  {  {
70      printf "building the mpack utility...  "      printf "building the mpack utility...  "
71      if test ! -x "$MPACKDIR/mpack" ; then      MPACK="$MPACKDIR/mpack"
72        if test ! -x $MPACK ; then
73          if test ! -d $MPACKDIR ; then          if test ! -d $MPACKDIR ; then
74              echo              echo
75              echo "Error: can't find \"$MPACKDIR\""              echo "Error: can't find \"$MPACKDIR\""
# Line 73  build_mpack() Line 78  build_mpack()
78              echo              echo
79              HAVE_MPACK=f              HAVE_MPACK=f
80          fi          fi
         printf "building mpack...  "  
81          if test "x$CC" = x ; then          if test "x$CC" = x ; then
82              export CC=cc              export CC=cc
83          fi          fi
84            printf "building mpack (using CC=$CC)...  "
85          ( cd $MPACKDIR && ./configure && $MAKE ) > tr_build_mpack.out 2>&1          ( cd $MPACKDIR && ./configure && $MAKE ) > tr_build_mpack.out 2>&1
86          RETVAL=$?          RETVAL=$?
87          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
# Line 87  build_mpack() Line 92  build_mpack()
92          else          else
93              rm -f tr_build_mpack.out              rm -f tr_build_mpack.out
94              HAVE_MPACK=t              HAVE_MPACK=t
95                echo "done"
96          fi          fi
97      else      else
98          HAVE_MPACK=t          HAVE_MPACK=t
99            echo "already exist"
100      fi      fi
     echo "OK"  
101  }  }
102    
103  testoutput_var()  testoutput_var()
# Line 174  testoutput_var() Line 180  testoutput_var()
180      return $digits_of_similarity      return $digits_of_similarity
181  }  }
182    
 dashnum()  
 {  
     # dashnum n1 n2 n3 ...  
     #  
     #  print numbers using %3i format or "--" if number = 99  
   
     for num in $@ ; do  
         if [ $num = 99 ]; then  
             printf ' --'  
         else  
             printf '%3i' $num  
         fi  
     done  
 }  
   
 check_for_add_mon_output()  
 {  
     # Check for additional types of monitor output  
     if test "x$1" = x ; then  
         return  
     fi  
   
     for ii in $PTRACERS_NUM ; do  
         eval "HAVE_PTR0"$ii"=f"  
     done  
   
     ptr_add="trcstat_ptracerXX_min trcstat_ptracerXX_max"  
     ptr_add="$ptr_add trcstat_ptracerXX_mean trcstat_ptracerXX_sd"  
     for ii in $PTRACERS_NUM ; do  
         for jj in $ptr_add ; do  
             name=`eval "echo $jj | sed -e 's|XX|0"$ii"|g'"`  
             tst=`grep $name $1 | wc -l | awk '{print $1}'`  
             if test ! "x$tst" = x0 ; then  
                 eval "HAVE_PTR0"$ii"=t"  
             fi  
         done  
         #  eval 'echo "HAVE_PTR0'$ii' = $HAVE_PTR0'$ii'"'  
     done  
 }  
   
183  testoutput_run()  testoutput_run()
184  {  {
185      # testoutput_run directory subdir reference_output      # testoutput_run directory subdir reference_output
# Line 231  testoutput_run() Line 197  testoutput_run()
197          listVar=`echo $listChk | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' \          listVar=`echo $listChk | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' \
198                                 | sed 's/+//g' | sed "s/^$sVar//"`                                 | sed 's/+//g' | sed "s/^$sVar//"`
199          if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(I)='$listVar'" 1>&2 ; fi          if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(I)='$listVar'" 1>&2 ; fi
200          for ii in 1 2 3 4 5 6 7 8 9 ; do          # check for ptracer output in reference_output file :
201            tst=`eval 'echo "$HAVE_PTR0'$ii'"'`          outpref=$1/results/$3
202           #echo "-- ptr test=" $tst "number of var=" `echo $listVar | awk '{print NF}'` 1>&2          ptr_mon="trcstat_ptracerXX_min trcstat_ptracerXX_max"
203            if test "x$tst" != xt ; then listVar=`echo "$listVar" | sed "s/ pt$ii..//g"` ; fi          ptr_mon="$ptr_mon trcstat_ptracerXX_mean trcstat_ptracerXX_sd"
204          done          for ii in $PTRACERS_NUM ; do
205          tst=`echo $sVar $listVar | awk '{ for(i=2;i<=NF;i++){t+=($i==$1)}; print t }'`              ptrfound=0
206                for jj in $ptr_mon ; do
207                    name=`eval "echo $jj | sed -e 's|XX|0"$ii"|g'"`
208                    tst=`grep $name $outpref | wc -l | awk '{print $1}'`
209                    if test ! "x$tst" = x0 ; then ptrfound=1 ; fi
210                done
211                if test $ptrfound = '1' ; then
212                    eval "HAVE_PTR0"$ii"=t"
213                else
214                    eval "HAVE_PTR0"$ii"=f"
215                  if test "x$ADM" = x -a "x$OADM" = x; then
216                  # remove this ptr from the list of output variable to check
217                  # echo "-- ptr test=" $tst "number of var=" `echo $listVar | awk '{print NF}'` 1>&2
218                    listVar=`echo "$listVar" | sed "s/ pt$ii..//g"`
219                  fi
220                fi
221            #   eval 'echo "HAVE_PTR0'$ii' = $HAVE_PTR0'$ii'"' 1>&2
222            done
223            tst=`echo $sVar $listVar | awk '{ for(i=2;i<=NF;i++){if($i==$1)t+=1}; print t }'`
224          if test $tst != 1 ; then          if test $tst != 1 ; then
225            if test $tst = 0 ; then echo "==> WARNING: selected var >$sVar< not found" 1>&2            if test $tst = 0 ; then echo "==> WARNING: selected var >$sVar< not found" 1>&2
226                   else echo "==> WARNING: found selected var >$sVar< $tst times" 1>&2 ; fi                   else echo "==> WARNING: found selected var >$sVar< $tst times" 1>&2 ; fi
# Line 280  testoutput_run() Line 264  testoutput_run()
264             testoutput_var $1 "trcstat_ptracer0"$ii"_mean" "p0"$ii"_mean" $2 $3; yy=$? ;;             testoutput_var $1 "trcstat_ptracer0"$ii"_mean" "p0"$ii"_mean" $2 $3; yy=$? ;;
265          'pt1sd'|'pt2sd'|'pt3sd'|'pt4sd'|'pt5sd') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`          'pt1sd'|'pt2sd'|'pt3sd'|'pt4sd'|'pt5sd') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
266             testoutput_var $1 "trcstat_ptracer0"$ii"_sd"   "p0"$ii"_StDv"  $2 $3; yy=$? ;;             testoutput_var $1 "trcstat_ptracer0"$ii"_sd"   "p0"$ii"_StDv"  $2 $3; yy=$? ;;
267           'Qntmn') testoutput_var $1 "extforcing_qnet_min" "Qnet minimum"  $2 $3; yy=$? ;;           'Qntmn') testoutput_var $1 "forcing_qnet_min" "Qnet minimum"  $2 $3; yy=$? ;;
268           'Qntmx') testoutput_var $1 "extforcing_qnet_max" "Qnet maximum"  $2 $3; yy=$? ;;           'Qntmx') testoutput_var $1 "forcing_qnet_max" "Qnet maximum"  $2 $3; yy=$? ;;
269           'Qntav') testoutput_var $1 "extforcing_qnet_mean" "Qnet mean"    $2 $3; yy=$? ;;           'Qntav') testoutput_var $1 "forcing_qnet_mean" "Qnet mean"       $2 $3; yy=$? ;;
270           'Qntsd') testoutput_var $1 "extforcing_qnet_sd"  "Qnet Std.Dev"  $2 $3; yy=$? ;;           'Qntsd') testoutput_var $1 "forcing_qnet_sd"  "Qnet Std.Dev"  $2 $3; yy=$? ;;
271           'aSImn') testoutput_var $1 "seaice_area_min"   "SIce Area min"   $2 $3; yy=$? ;;           'aSImn') testoutput_var $1 "seaice_area_min"   "SIce Area min"   $2 $3; yy=$? ;;
272           'aSImx') testoutput_var $1 "seaice_area_max"   "SIce Area max"   $2 $3; yy=$? ;;           'aSImx') testoutput_var $1 "seaice_area_max"   "SIce Area max"   $2 $3; yy=$? ;;
273           'aSIav') testoutput_var $1 "seaice_area_mean"  "SIce Area mean"  $2 $3; yy=$? ;;           'aSIav') testoutput_var $1 "seaice_area_mean"  "SIce Area mean"  $2 $3; yy=$? ;;
274           'aSIsd') testoutput_var $1 "seaice_area_sd"    "SIce Area StDv"  $2 $3; yy=$? ;;           'aSIsd') testoutput_var $1 "seaice_area_sd"    "SIce Area StDv"  $2 $3; yy=$? ;;
275           'hSImn') testoutput_var $1 "seaice_heff_min"   "SIce Heff min"   $2 $3; yy=$? ;;           'hSImn') testoutput_var $1 "seaice_heff_min"   "SIce Heff min"   $2 $3; yy=$? ;;
276           'hSImx') testoutput_var $1 "seaice_heff_max"   "SIce Hell max"   $2 $3; yy=$? ;;           'hSImx') testoutput_var $1 "seaice_heff_max"   "SIce Heff max"   $2 $3; yy=$? ;;
277           'hSIav') testoutput_var $1 "seaice_heff_mean"  "SIce Hell mean"  $2 $3; yy=$? ;;           'hSIav') testoutput_var $1 "seaice_heff_mean"  "SIce Heff mean"  $2 $3; yy=$? ;;
278           'hSIsd') testoutput_var $1 "seaice_heff_sd"    "SIce Hell StDv"  $2 $3; yy=$? ;;           'hSIsd') testoutput_var $1 "seaice_heff_sd"    "SIce Heff StDv"  $2 $3; yy=$? ;;
279          'AthSiG') testoutput_var $1 "thSI_Ice_Area_G" "thSIc Area Global" $2 $3; yy=$? ;;          'AthSiG') testoutput_var $1 "thSI_Ice_Area_G" "thSIc Area Global" $2 $3; yy=$? ;;
280          'AthSiS') testoutput_var $1 "thSI_Ice_Area_S" "thSIc Area South"  $2 $3; yy=$? ;;          'AthSiS') testoutput_var $1 "thSI_Ice_Area_S" "thSIc Area South"  $2 $3; yy=$? ;;
281          'AthSiN') testoutput_var $1 "thSI_Ice_Area_N" "thSIc Area North"  $2 $3; yy=$? ;;          'AthSiN') testoutput_var $1 "thSI_Ice_Area_N" "thSIc Area North"  $2 $3; yy=$? ;;
# Line 331  genmakemodel() Line 315  genmakemodel()
315          (          (
316              cd $1;              cd $1;
317              command="$GENMAKE2  -ds -m $MAKE"              command="$GENMAKE2  -ds -m $MAKE"
318              if test "x$ADM" = x ; then              if test "x$ADM" = xt ; then
                 command="$command --mods=../code"  
             else  
319                  command="$command --mods=../code_ad"                  command="$command --mods=../code_ad"
320                elif test "x$OADM" = xt ; then
321                    command="$command -adof ../../../tools/adjoint_options/adjoint_oad -mods '../code_oad ../../OpenAD/code_oad_all'"
322                else
323                    command="$command -mods=../code"
324              fi              fi
325              if test "x$OPTFILE" != xNONE ; then              if test "x$OPTFILE" != xNONE ; then
326                  command="$command --optfile=$OPTFILE"                  command="$command -optfile=$OPTFILE"
327              fi              fi
328              if test "x$IEEE" != x ; then              if test "x$IEEE" != x ; then
329                  command="$command -ieee"                  command="$command -ieee"
330              fi              fi
331                if test "x$GSL" = xt ; then
332                    command="$command -gsl"
333                fi
334              if test "x$MPI" = xt ; then              if test "x$MPI" = xt ; then
335                  command="$command -mpi"                  command="$command -mpi"
336              fi              fi
337                if test "x$MULTI_THREAD" = xt ; then
338                #- run multi-threaded using OpenMP:
339                    command="$command -omp"
340                fi
341              if test "x$TS" = xt ; then              if test "x$TS" = xt ; then
342                  command="$command -ts"                  command="$command -ts"
343              fi              fi
# Line 356  genmakemodel() Line 349  genmakemodel()
349              fi              fi
350              fi              fi
351              printf 'genmake ... ' 1>&2              printf 'genmake ... ' 1>&2
352              $command > make.log 2>&1              # $command > make.log 2>&1
353                eval $command > make.log 2>&1
354              RETVAL=$?              RETVAL=$?
355              #  Reduce the size of the testing emails!              #  Reduce the size of the testing emails!
356              head -100 Makefile > $CDIR/Makefile_head              head -100 Makefile > $CDIR/Makefile_head
# Line 391  makeclean() Line 385  makeclean()
385                      cp make.log $CDIR"/make.log"                      cp make.log $CDIR"/make.log"
386                      return 1                      return 1
387                  fi                  fi
388                    echo successful 1>&2
389                else
390                    echo ''
391              fi              fi
             echo successful 1>&2  
392              exit 0              exit 0
393          )          )
394      fi      fi
# Line 414  run_clean() Line 410  run_clean()
410              find . -type l -exec rm {} \;              find . -type l -exec rm {} \;
411              rm -f $EXECUTABLE *.txt STD* *diagnostics.log datetime              rm -f $EXECUTABLE *.txt STD* *diagnostics.log datetime
412              rm -rf mnc_test_*              rm -rf mnc_test_*
413                rm -f *_MIT_CE_000.opt0000 costfunction*0000
414              echo successful 1>&2              echo successful 1>&2
415              exit 0              exit 0
416          )          )
# Line 450  makemodel() Line 447  makemodel()
447          cd $1;          cd $1;
448          if test -r Makefile ; then          if test -r Makefile ; then
449              printf 'make ... ' 1>&2              printf 'make ... ' 1>&2
450              if test "x$ADM" = x ; then              if test "x$ADM" = xt ; then
451                    $MAKE adall >> make.log 2>&1
452                elif test "x$OADM" = xt ; then
453                    $MAKE adAll >> make.log 2>&1
454                else
455                  if test "x$JOBS" = x ; then                  if test "x$JOBS" = x ; then
456                      $MAKE >> make.log 2>&1                      $MAKE >> make.log 2>&1
457                  else                  else
458                      $MAKE -j $JOBS >> make.log 2>&1                      $MAKE -j $JOBS >> make.log 2>&1
459                  fi                  fi
             else  
                 $MAKE adall >> make.log 2>&1  
460              fi              fi
461              RETVAL=$?              RETVAL=$?
462              if test "x$RETVAL" != x0 ; then              if test "x$RETVAL" != x0 ; then
463                  tail make.log                  tail make.log
464                  echo failed 1>&2                  echo failed 1>&2
465                  cp make.log $CDIR"/make.log"                  cp make.log $CDIR"/make.log"
466                    rm -f $EXECUTABLE
467                  return 1                  return 1
468              else              else
469                  echo successful 1>&2                  echo successful 1>&2
# Line 484  symlink_mpifiles() Line 484  symlink_mpifiles()
484      CODE_DIR=$dir/$code_dir      CODE_DIR=$dir/$code_dir
485            
486      # These are files that should replace their counter-part when using -mpi      # These are files that should replace their counter-part when using -mpi
487      MPI_FILES=`(cd $CODE_DIR; find . -name "*_mpi")`      MPI_FILES=`(cd $CODE_DIR; find . -name "*_mpi" -print)`
488    
489      #  Is this an MPI run?      #  Is this an MPI run?
490      if test "x$MPI" = xt ; then      if test "x$MPI" = xt ; then
# Line 528  linkdata() Line 528  linkdata()
528      if test -d $1 ; then      if test -d $1 ; then
529          (          (
530              cd $1 ; shift              cd $1 ; shift
531                inpMPI=`(cd ../$1 ; find . -name "*.mpi" -print | sed 's:^\./::')`
532                for xx in $inpMPI ; do
533                  if test -r "../"$1"/"$xx ; then
534                    # found 1 _mpi sfx file in 1rst input dir and it is readable
535                    yy=`echo $xx | sed 's:\.mpi$::'`
536                    if test "x$MPI" = "xt" ; then
537                    # mpi test: remove symbolic link & link _mpi sfx file
538                        if test -h $yy ; then rm -f $yy ; fi
539                        if test ! -r $yy ; then
540                            ln -sf "../"$1"/"$xx $yy ;
541                            printf "$xx " 1>&2
542                        fi
543                    else
544                    # not mpi test: remove symbolic link
545                        if test -h $yy ; then rm -f $yy ; fi
546                    fi
547                  fi
548                done
549              if test -r "../"$1"/eedata.mth" ; then              if test -r "../"$1"/eedata.mth" ; then
550              # found eedata.mth in 1rst input dir and it is readable              # found eedata.mth in 1rst input dir and it is readable
551                  if test "x$MULTI_THREAD" = "xt" ; then                  if test "x$MULTI_THREAD" = "xt" ; then
# Line 542  linkdata() Line 560  linkdata()
560                      if test -h eedata ; then rm -f eedata ; fi                      if test -h eedata ; then rm -f eedata ; fi
561                  fi                  fi
562              fi              fi
563                prevDir='NONE'
564              for ldir in $* ; do              for ldir in $* ; do
565                  if test -d "../"$ldir ; then                  if test -d "../"$ldir -a $ldir != $prevDir ; then
566                      printf 'ldir='${ldir} 1>&2                      printf 'ldir='${ldir} 1>&2
567                      files=`( cd "../"$ldir ; ls -1 | grep -v CVS )`                      files=`( cd "../"$ldir ; ls -1 | grep -v CVS )`
568                      for i in $files ; do                      for i in $files ; do
# Line 559  linkdata() Line 578  linkdata()
578                      fi                      fi
579                      printf ' ; ' 1>&2                      printf ' ; ' 1>&2
580                  fi                  fi
581                    prevDir=$ldir
582              done              done
583          )          )
584      fi      fi
# Line 575  runmodel() Line 595  runmodel()
595          printf 'runmodel in %s ...' $1 1>&2          printf 'runmodel in %s ...' $1 1>&2
596          # make output.txt          # make output.txt
597          echo          echo
598            if test -L $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then
599                diff -q $EXECUTABLE "../"$builddir"/"$EXECUTABLE > /dev/null 2>&1
600                outD=$? ; if test $outD != 0 ; then rm -f $EXECUTABLE ; fi
601            fi
602          if test ! -x $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then          if test ! -x $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then
603              echo " link" $EXECUTABLE "from dir ../"$builddir > run.log_00              echo " link" $EXECUTABLE "from dir ../"$builddir > run.log_tmp
604              ln -sf "../"$builddir"/"$EXECUTABLE .              ln -sf "../"$builddir"/"$EXECUTABLE .
605          fi          fi
606          if test ! -x $EXECUTABLE ; then          if test ! -x $EXECUTABLE ; then
607                  rm -f run.log ; touch run.log                  rm -f $RUNLOG ; touch $RUNLOG
608                  if test -f run.log_00 ; then cat run.log_00 >> run.log ; fi                  if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
609                  echo " no executable:" $EXECUTABLE >> run.log                  echo " no executable:" $EXECUTABLE >> $RUNLOG
610                  RETVAL=8                  RETVAL=8
611                  ENDVAL=-1                  ENDVAL=-1
612          else          else
613              if test ! -f $OUTPUTFILE -o $OUTPUTFILE -ot $EXECUTABLE ; then              if test ! -f $OUTPUTFILE -o $OUTPUTFILE -ot $EXECUTABLE ; then
614                # output do not exist or is older than executable:                # output do not exist or is older than executable:
615                  rm -f run.log ; touch run.log                  rm -f $RUNLOG ; touch $RUNLOG
616                  if test -f run.log_00 ; then cat run.log_00 >> run.log ; fi                  if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
617                  ( eval $COMMAND ) >> run.log 2>&1                  ( eval $COMMAND ) >> $RUNLOG 2>&1
618                  RETVAL=$?                  RETVAL=$?
619              else              else
620                  RETVAL=0                  RETVAL=0
621                  if test -f run.log ; then                  if test -f $RUNLOG ; then
622                      if test -f run.log_00 ; then cat run.log_00 >> run.log ; fi                      if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
623                      echo "---------->> $OUTPUTFILE is up to date " >> run.log 2>&1                      echo "---------->> $OUTPUTFILE is up to date " >> $RUNLOG 2>&1
624                  else                  else
625                      touch run.log                      touch $RUNLOG
626                      if test -f run.log_00 ; then cat run.log_00 >> run.log ; fi                      if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
627                      echo "---------->> $OUTPUTFILE is up to date " >> run.log 2>&1                      echo "---------->> $OUTPUTFILE is up to date " >> $RUNLOG 2>&1
628                      echo " no previous run.log: assume NORMAL END" >> run.log 2>&1                      echo " no previous $RUNLOG: assume NORMAL END" >> $RUNLOG 2>&1
629                  fi                  fi
630              fi              fi
631              ENDVAL=`cat run.log | grep -v 'ABNORMAL END' | grep -c 'NORMAL END'`              ENDVAL=`cat $RUNLOG | grep -v 'ABNORMAL END' | grep -c 'NORMAL END'`
632          fi          fi
633          rm -f run.log_00          rm -f run.log_tmp
         #if test "x$RETVAL" = x0 ; then  
634          if [ $RETVAL -eq 0 -a $ENDVAL -gt 0 ] ; then          if [ $RETVAL -eq 0 -a $ENDVAL -gt 0 ] ; then
635              tail run.log              tail $RUNLOG
636              echo successful 1>&2              echo successful 1>&2
637              # === Reduce the size of the testing emails!              # === Reduce the size of the testing emails!
638              #cp $OUTPUTFILE $CDIR"/"$OUTPUTFILE              #cp $OUTPUTFILE $CDIR"/"$OUTPUTFILE
639              if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi              if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi
640              return 0              return 0
641            elif [ $RETVAL -ne 0 -a $ENDVAL -gt 0 ] ; then
642                #-- for some weird cases (run is finihed but with error code)
643                tail $RUNLOG
644                echo finished with error '(run:' $RETVAL ' end:' $ENDVAL ')' 1>&2
645                return 0
646          else          else
647              tail run.log              tail $RUNLOG
648              echo failed '(run:' $RETVAL ' end:' $ENDVAL ')' 1>&2              echo failed '(run:' $RETVAL ' end:' $ENDVAL ')' 1>&2
649              cp run.log $CDIR"/run.log"              cp $RUNLOG $CDIR"/"$RUNLOG
650              if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi              if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi
651              return 1              return 1
652          fi          fi
# Line 629  createcodelet() Line 657  createcodelet()
657  {  {
658      # create codelet for comparing model output      # create codelet for comparing model output
659    
660      printf "creating the comparison code...  "      printf "creating the comparison code (using CC=$CC)...  "
661      cat > tr_cmpnum.c <<EOF      cat > tr_cmpnum.c <<EOF
662  #include <stdio.h>  #include <stdio.h>
663  #include <math.h>  #include <math.h>
# Line 719  scandirs() Line 747  scandirs()
747  }  }
748    
749    
750    check_eedata()
751    {
752        # check_eedata size.h eedata
753        if [ $# -eq 2 ] ; then
754          if test -f $1 -a -f $2 ; then
755          sx=`grep "^     & *nSx *=" $1 | sed "s/^     & *nSx *=//" | sed 's/, *$//'`
756          nx=`grep "^ *nTx *=" $2 | tail -1 | sed 's/^ *nTx *= *//' | sed "s/, *$//"`
757          if test "x$nx" = x ; then
758            rx=10
759          else
760            rx=`expr $sx % $nx`
761          fi
762          sy=`grep "^     & *nSy *=" $1 | sed "s/^     & *nSy *=//" | sed 's/, *$//'`
763          ny=`grep "^ *nTy *=" $2 | tail -1 | sed 's/^ *nTy *= *//' | sed "s/, *$//"`
764          if test "x$ny" = x ; then
765            ry=20
766          else
767            ry=`expr $sy % $ny`
768          fi
769          echo `expr $rx + $ry`
770        else
771          echo '-1'
772          fi
773        else
774          echo '-2'
775        fi
776    
777    }
778    
779  ###############################################################################  ###############################################################################
780    
781    
# Line 726  scandirs() Line 783  scandirs()
783  debug=0  debug=0
784  verbose=1  verbose=1
785  clean=0  clean=0
 expts=''  
 # ieee=1  
786    
787  IEEE=true  IEEE=true
788  if test "x$MITGCM_IEEE" != x ; then  if test "x$MITGCM_IEEE" != x ; then
789      IEEE=$MITGCM_IEEE      IEEE=$MITGCM_IEEE
790  fi  fi
791    GSL=f
792    
793  CLEANUP=f  CLEANUP=f
794  QUICK=f  QUICK=f
# Line 749  TESTDIRS= Line 804  TESTDIRS=
804  SKIPDIRS=  SKIPDIRS=
805  MPACKDIR="../tools/mpack-1.6"  MPACKDIR="../tools/mpack-1.6"
806  HAVE_MPACK=  HAVE_MPACK=
807  MPACK="$MPACKDIR/mpack"  MPACK=
808  COMMAND=  COMMAND=
809  if test "x$MAKE" = x ; then  if test "x$MAKE" = x ; then
810      MAKE=make      MAKE=make
# Line 764  OUTDIR= Line 819  OUTDIR=
819  DELDIR=  DELDIR=
820    
821  ADM=  ADM=
822    OADM=
823    
824  # Additional monitor types  # list of pTracers to check for monitor output
825  PTRACERS_NUM="1 2 3 4 5"  PTRACERS_NUM="1 2 3 4 5"
826    
827  MATCH_CRIT=13  MATCH_CRIT=13
# Line 798  for ac_option ; do Line 854  for ac_option ; do
854              ac_prev=ADDRESSES ;;              ac_prev=ADDRESSES ;;
855          -addr=* | --addr=*)          -addr=* | --addr=*)
856              ADDRESSES=$ac_optarg ;;              ADDRESSES=$ac_optarg ;;
857            -mpackdir | --mpackdir | -mpd | --mpd)
858                ac_prev=MPACKDIR ;;
859            -mpackdir=* | --mpackdir=* | -mpd=* | --mpd=*)
860                MPACKDIR=$ac_optarg ;;
861    
862          -tdir | --tdir | -t | --t)          -tdir | --tdir | -t | --t)
863              ac_prev=TESTDIRS ;;              ac_prev=TESTDIRS ;;
# Line 861  for ac_option ; do Line 921  for ac_option ; do
921    
922          -adm | -ad) ADM=t ;;          -adm | -ad) ADM=t ;;
923    
924            -oad) OADM=t; NODEPEND=t ;;
925    
926          -ieee) IEEE=true ;;          -ieee) IEEE=true ;;
927          -noieee) IEEE= ;;          -noieee) IEEE= ;;
928            -gsl) GSL=t ;;
929    
930          -verbose) verbose=2 ;;          -verbose) verbose=2 ;;
931          -debug) debug=1 ;;          -debug) debug=1 ;;
# Line 899  fi Line 962  fi
962  #- setting for forward or ADM testing  #- setting for forward or ADM testing
963  if test "x$ADM" = xt ; then  if test "x$ADM" = xt ; then
964      code_dir=code_ad      code_dir=code_ad
965      input_dirs='input_ad input'      inputdir=input_ad
966      ref_outp="output_adm.txt"      ref_outp="output_adm.txt"
967      EXECUTABLE="mitgcmuv_ad"      EXECUTABLE="mitgcmuv_ad"
968    elif test "x$OADM" = xt ; then
969        code_dir=code_oad
970        inputdir=input_oad
971        ref_outp="output_oadm.txt"
972        EXECUTABLE="mitgcmuv_ad"
973  else  else
974      code_dir=code      code_dir=code
975      input_dirs='input'      inputdir=input
976      ref_outp="output.txt"      ref_outp="output.txt"
977      EXECUTABLE="mitgcmuv"      EXECUTABLE="mitgcmuv"
978  fi  fi
# Line 954  if test "x$OPTFILE" = xNONE -a "x$MITGCM Line 1022  if test "x$OPTFILE" = xNONE -a "x$MITGCM
1022      OPTFILE=$MITGCM_OF      OPTFILE=$MITGCM_OF
1023  fi  fi
1024    
1025    RUNLOG="run.log"
1026  OUTPUTFILE=$ref_outp  OUTPUTFILE=$ref_outp
1027  if test "x$COMMAND" = x ; then  if test "x$COMMAND" = x ; then
1028      COMMAND="./$EXECUTABLE > $OUTPUTFILE"      COMMAND="./$EXECUTABLE > $OUTPUTFILE"
# Line 968  echo "OK (COMMAND= $COMMAND )" Line 1037  echo "OK (COMMAND= $COMMAND )"
1037  #  (use default or load experiment-specific list from file "tr_checklist")  #  (use default or load experiment-specific list from file "tr_checklist")
1038  # content : 1rst = main variable used to decide if it pass or FAIL  # content : 1rst = main variable used to decide if it pass or FAIL
1039  #         others = number of matching digits to be printed in summary.txt  #         others = number of matching digits to be printed in summary.txt
1040  if test "x$ADM" = x ; then  if test "x$ADM" = x -a "x$OADM" = x; then
1041      DEF_CHECK_LIST='PS PS T+ S+ U+ V+ pt1+ pt2+ pt3+ pt4+ pt5+'      DEF_CHECK_LIST='PS PS T+ S+ U+ V+ pt1+ pt2+ pt3+ pt4+ pt5+'
1042      EMPTY_RESULTS='.. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..'      EMPTY_RESULTS='.. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..'
1043      LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`      LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
# Line 983  fi Line 1052  fi
1052  #  create the FORTRAN comparison code  #  create the FORTRAN comparison code
1053  createcodelet  createcodelet
1054    
1055  #  build the mpack utility  #  build the mpack utility (if ADDRESSES = NONE, do it to test the build)
1056  if test "x$ADDRESSES" = xNONE -o "x$ADDRESSES" = x ; then  if test "x$ADDRESSES" = x ; then
1057      echo "skipping mpack build"      echo "skipping mpack build"
1058  else  else
1059      build_mpack      build_mpack
1060  fi  fi
1061    
1062  #  Create a uniquely named directory to store results  #  Create a uniquely named directory to store results
1063    CMDLINE=$0
1064    for xx in "$@" ; do nw=`echo $xx | wc -w`
1065        if test $nw = '1' ; then CMDLINE="$CMDLINE $xx"
1066                            else CMDLINE="$CMDLINE '$xx'" ; fi
1067    done
1068    #for xx in "$@" ; do CMDLINE="$CMDLINE '$xx'" ; done
1069  MACH=`hostname`  MACH=`hostname`
1070  UNAMEA=`uname -a`  UNAMEA=`uname -a`
1071  DATE=`date +%Y%m%d`  DATE=`date +%Y%m%d`
1072  BASE="tr_"$MACH"_"$DATE"_"  BASE="tr_"$MACH"_"$DATE"_"
1073  if test "x$OUTDIR" != x ; then  if test "x$OUTDIR" != x ; then
1074      BASE="tr_"$OUTDIR"_"$DATE"_"      BASE="tr_"$OUTDIR"_"$DATE"_"
1075    else
1076        short_name=`hostname | sed 's/\..*$//'`
1077        BASE="tr_"$short_name"_"$DATE"_"
1078  fi  fi
1079  DNUM=0  DNUM=0
1080  DRESULTS="$BASE$DNUM"  DRESULTS="$BASE$DNUM"
# Line 1011  if test "x$RETVAL" != x0 ; then Line 1089  if test "x$RETVAL" != x0 ; then
1089      exit 1      exit 1
1090  fi  fi
1091  SUMMARY="$DRESULTS/summary.txt"  SUMMARY="$DRESULTS/summary.txt"
 printf "Start time:  " >> $SUMMARY  
1092  start_date=`date`  start_date=`date`
1093  echo $start_date > $SUMMARY  echo $start_date > $SUMMARY
1094    echo 'run:' $CMDLINE >> $SUMMARY
1095    echo 'on :' $UNAMEA  >> $SUMMARY
1096    
1097  of_path=  of_path=
1098  if test "x$OPTFILE" != xNONE ; then  if test "x$OPTFILE" != xNONE ; then
# Line 1042  else Line 1121  else
1121  fi  fi
1122  echo  echo
1123  echo >> $SUMMARY  echo >> $SUMMARY
1124  if test "x$ADM" = x ; then  if test "x$ADM" = x -a "x$OADM" = x; then
1125      if [ $MATCH_CRIT -lt 10 ] ;      if [ $MATCH_CRIT -lt 10 ] ;
1126      then line_0="default  "$MATCH_CRIT ;      then line_0="default  "$MATCH_CRIT ;
1127      else line_0="default "$MATCH_CRIT ; fi      else line_0="default "$MATCH_CRIT ; fi
# Line 1053  if test "x$ADM" = x ; then Line 1132  if test "x$ADM" = x ; then
1132      line_3="N n k u  2  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d"      line_3="N n k u  2  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d"
1133      line_4="2 d e n  d  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  ."      line_4="2 d e n  d  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  ."
1134      for ii in $PTRACERS_NUM ; do      for ii in $PTRACERS_NUM ; do
         #  tst=`eval 'echo $HAVE_PTR0'$ii`  
         #  if test "x$tst" = xt ; then  
1135          line_0="$line_0  --PTR 0"$ii"--"          line_0="$line_0  --PTR 0"$ii"--"
1136          line_1="$line_1        m  s"          line_1="$line_1        m  s"
1137          line_2="$line_2  m  m  e  ."          line_2="$line_2  m  m  e  ."
1138          line_3="$line_3  i  a  a  d"          line_3="$line_3  i  a  a  d"
1139          line_4="$line_4  n  x  n  ."          line_4="$line_4  n  x  n  ."
         #  fi  
1140      done      done
1141      echo "$line_0" | tee -a $SUMMARY      echo "$line_0" | tee -a $SUMMARY
1142      echo "$line_1" | tee -a $SUMMARY      echo "$line_1" | tee -a $SUMMARY
# Line 1087  fi Line 1163  fi
1163  #  ...and each test directory...  #  ...and each test directory...
1164  for dir in $TESTDIRS ; do  for dir in $TESTDIRS ; do
1165            
1166        # set builddir & rundir:
1167        builddir="build"
1168        if test ! -d $dir/$builddir ; then mkdir $dir/$builddir ; fi
1169        rundir="run"
1170        if test ! -d $dir/$rundir ; then
1171            rundir=$builddir
1172        fi
1173        CODE_DIR=$dir/$code_dir
1174        BUILD_DIR=$dir/$builddir
1175    
1176      #  Cleanup only!      #  Cleanup only!
1177      if test "x$CLEANUP" = xt ; then      if test "x$CLEANUP" = xt ; then
1178          if test -r $dir/build/Makefile ; then          echo -n '  --- dir:' $BUILD_DIR ': '
1179              echo '  ------  clean dir:' $dir/build          makeclean $BUILD_DIR
1180              ( cd $dir/build ; make CLEAN )          rm -f $BUILD_DIR/$EXECUTABLE
1181          fi          if test -d $dir/$rundir/CVS ; then
1182          if test -d $dir/run/CVS ; then              echo -n '  --- dir:' $dir/$rundir ': '
1183              echo '  ------  clean dir:' $dir/run              run_clean $dir/$rundir
1184              run_clean $dir/run          fi
1185            trdir=`( cd $dir ; find . -type d -name "tr_run.*" -print | sed 's/^.\///')`
1186            ttd=`echo $trdir | wc -w`
1187            if test $ttd != 0 ; then
1188                echo '  --- rm dir:' $trdir
1189                ( cd $dir ; rm -rf $trdir )
1190          fi          fi
         (  
             cd $dir  
             rm -rf tr_run.*  
         )  
1191          continue          continue
1192      fi      fi
1193    
1194      #  Verify that the testdir exists and contains previous      #  Verify that the testdir exists and contains previous
1195      #  results in the correct location--or skip this directory!      #  results in the correct location--or skip this directory!
1196      fout=      fout=$dir"/results/"$ref_outp
     if test "x$ADM" = x ; then  
         fout=$dir"/results/"$ref_outp  
     else  
         fout=$dir"/results_ad/"$ref_outp  
     fi  
1197      if test ! -r $fout ; then      if test ! -r $fout ; then
1198          echo "can't read \"$fout\" -- skipping $dir"          echo "can't read \"$fout\" -- skipping $dir"
1199          continue          continue
1200      fi      fi
     if test "x$ADM" = x ; then  
         check_for_add_mon_output  $fout  
     fi  
   
     # Check for additional types of monitor output  
1201    
1202      builddir="build"      # Check for specific files for particular type of run
     if test ! -d $dir/$builddir ; then mkdir $dir/$builddir ; fi  
     rundir="run"  
     if test ! -d $dir/$rundir ; then  
         rundir=$builddir  
     fi  
     CODE_DIR=$dir/$code_dir  
     BUILD_DIR=$dir/$builddir  
1203    
1204      if test ! -r $CODE_DIR"/SIZE.h_mpi" -a "x$MPI" = "xt" ; then      if test ! -r $CODE_DIR"/SIZE.h_mpi" -a "x$MPI" = "xt" ; then
1205          echo "can't find \"$CODE_DIR/SIZE.h_mpi\" -- skipping $dir"          echo "can't find \"$CODE_DIR/SIZE.h_mpi\" -- skipping $dir"
# Line 1139  for dir in $TESTDIRS ; do Line 1209  for dir in $TESTDIRS ; do
1209          echo "can't find \"$dir/input/eedata.mth\" -- skipping $dir"          echo "can't find \"$dir/input/eedata.mth\" -- skipping $dir"
1210          continue          continue
1211      fi      fi
1212        if test "x$MPI" = "xt" -a "x$MULTI_THREAD" = "xt" ; then
1213          retv=`check_eedata $CODE_DIR"/SIZE.h_mpi" $dir"/input/eedata.mth"`
1214          if test $retv != 0 ; then
1215            echo "input/eedata.mth tiling misfit -- skipping $dir"
1216            continue
1217          fi
1218        fi
1219    
1220      #  Check whether there are "extra runs" for this testdir      #  Check whether there are "extra runs" for this testdir
1221      extra_runs=      extra_runs=
1222      if test "x$ADM" = x ; then      ex_run_dirs=`( cd $dir ; echo $inputdir.* )`
1223          ex_run_dirs=`( cd $dir ; echo input.* )`      #echo "ex_run_dirs='$ex_run_dirs'"
1224          #echo "ex_run_dirs='$ex_run_dirs'"      for exd in $ex_run_dirs ; do
1225          for exd in $ex_run_dirs ; do          name=`echo $exd | sed -e "s/$inputdir\.//"`
1226              name=`echo $exd | sed -e 's/input.//g'`          refExOut=`echo $ref_outp | sed "s/\./.${name}./"`
1227              outf="$dir/results/output.$name.txt"          outf="$dir/results/$refExOut"
1228              if test -f $outf -a -r $outf ; then          if test -f $outf -a -r $outf ; then
1229                  if test "x$MULTI_THREAD" = "xt" ; then            if test "x$MULTI_THREAD" = "xt" ; then
1230                      if test -r $dir"/"$exd"/eedata.mth" ; then              if test -r $dir"/"$exd"/eedata.mth" ; then
1231                          extra_runs="$extra_runs $name"                if test "x$MPI" = "xt" ; then
1232                      #else echo $dir"/"$exd"/eedata.mth: not found"                  retv=`check_eedata $CODE_DIR"/SIZE.h_mpi" $dir"/"$exd"/eedata.mth"`
1233                      fi                  if test $retv = 0 ; then
                 else  
1234                      extra_runs="$extra_runs $name"                      extra_runs="$extra_runs $name"
1235                    else
1236                        echo $exd"/eedata.mth tiling misfit -- skipping $dir"
1237                  fi                  fi
1238                  else
1239                    extra_runs="$extra_runs $name"
1240                  fi
1241                #else echo $dir"/"$exd"/eedata.mth: not found"
1242              fi              fi
1243          done            else
1244      fi              extra_runs="$extra_runs $name"
1245              fi
1246            fi
1247        done
1248    
1249      echo "-------------------------------------------------------------------------------"      echo "-------------------------------------------------------------------------------"
1250      echo      echo
# Line 1188  for dir in $TESTDIRS ; do Line 1273  for dir in $TESTDIRS ; do
1273              && symlink_mpifiles $dir $code_dir $builddir \              && symlink_mpifiles $dir $code_dir $builddir \
1274              && makedependmodel $dir/$builddir && makedepend=Y \              && makedependmodel $dir/$builddir && makedepend=Y \
1275              && makemodel $dir/$builddir && make=Y \              && makemodel $dir/$builddir && make=Y \
1276              && linkdata $dir/$rundir $input_dirs \              && linkdata $dir/$rundir $inputdir input \
1277              && runmodel $dir/$rundir && run=Y \              && runmodel $dir/$rundir && run=Y \
1278              && results=`testoutput_run $dir $rundir $ref_outp`              && results=`testoutput_run $dir $rundir $ref_outp`
1279      fi      fi
1280            
1281      echo      echo
 # --> same processing for adjoint & forward test  
1282          fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`          fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
1283          echo          echo
1284          echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY          echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY
# Line 1204  for dir in $TESTDIRS ; do Line 1288  for dir in $TESTDIRS ; do
1288          echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"          echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
1289          echo "DATE='$DATE'" >> $CDIR"/summary.txt"          echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1290          echo "tdir='$dir'" >> $CDIR"/summary.txt"          echo "tdir='$dir'" >> $CDIR"/summary.txt"
1291            if test "x$ADM" = xt ; then
1292                head -1 $dir/$builddir/taf_ad.log >> $CDIR"/summary.txt"
1293                grep -A3 'Seconds in section "ALL' $dir/$rundir/$OUTPUTFILE \
1294                                    >> $CDIR"/summary.txt"
1295            fi
1296    
1297          for ex in $extra_runs ; do          for ex in $extra_runs ; do
1298              unset run              unset run
1299              results=$EMPTY_RESULTS              results=$EMPTY_RESULTS
1300                #  reference output file
1301                refExOut=`echo $ref_outp | sed "s/\./.${ex}./g"`
1302              #  Create an output dir for each OPTFILE/tdir.ex combination              #  Create an output dir for each OPTFILE/tdir.ex combination
1303              rel_CDIR=$DRESULTS"/"$dir"."$ex              rel_CDIR=$DRESULTS"/"$dir"."$ex
1304              mkdir $rel_CDIR              mkdir $rel_CDIR
1305              CDIR=`pwd`"/$rel_CDIR"              CDIR=`pwd`"/$rel_CDIR"
1306              test ! -e "$dir/tr_run.$ex" && mkdir "$dir/tr_run.$ex"              test ! -e "$dir/tr_run.$ex" && mkdir "$dir/tr_run.$ex"
1307              run_clean $dir/tr_run.$ex              run_clean $dir/tr_run.$ex
1308              linkdata $dir/tr_run.$ex input.$ex input              linkdata $dir/tr_run.$ex $inputdir.$ex $inputdir input
1309              runmodel $dir/tr_run.$ex && run=Y \              runmodel $dir/tr_run.$ex && run=Y \
1310                  && results=`testoutput_run $dir tr_run.$ex "output.${ex}.txt"`              && results=`testoutput_run $dir tr_run.$ex $refExOut`
1311              fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`              fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
1312              fres="$fres.$ex"              fres="$fres.$ex"
1313              echo              echo
# Line 1227  for dir in $TESTDIRS ; do Line 1318  for dir in $TESTDIRS ; do
1318              echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"              echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
1319              echo "DATE='$DATE'" >> $CDIR"/summary.txt"              echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1320              echo "tdir='$dir.$ex'" >> $CDIR"/summary.txt"              echo "tdir='$dir.$ex'" >> $CDIR"/summary.txt"
1321                if test "x$ADM" = xt ; then
1322                    head -1 $dir/$builddir/taf_ad.log >> $CDIR"/summary.txt"
1323                    grep -A3 'Seconds in section "ALL' $dir/tr_run.$ex/$OUTPUTFILE \
1324                                       >> $CDIR"/summary.txt"
1325                fi
1326              if test "x$POSTCLEAN" = xt ; then              if test "x$POSTCLEAN" = xt ; then
1327                  run_clean $dir/tr_run.$ex                  run_clean $dir/tr_run.$ex
1328              fi              fi
1329          done          done
 # <-- same processing for adjoint & forward test  
     if test "x$ADM" = xt ; then  
         grep -A3 'Seconds in section "ALL' $dir/$rundir/$OUTPUTFILE \  
                            >> $CDIR"/summary.txt"  
     fi  
1330    
1331      #postclean $dir/$builddir      #postclean $dir/$builddir
1332      if test "x$POSTCLEAN" = xt ; then      if test "x$POSTCLEAN" = xt ; then
# Line 1248  for dir in $TESTDIRS ; do Line 1339  for dir in $TESTDIRS ; do
1339  done  done
1340    
1341  printf "Start time:  " >> $SUMMARY  printf "Start time:  " >> $SUMMARY
1342  echo $start_date >> $SUMMARY  echo "$start_date" >> $SUMMARY
1343  printf "End time:    " >> $SUMMARY  printf "End time:    " >> $SUMMARY
1344  date >> $SUMMARY  date >> $SUMMARY
1345    
# Line 1273  else Line 1364  else
1364              echo "An email containing results was sent to the following addresses:"              echo "An email containing results was sent to the following addresses:"
1365              echo "  \"$ADDRESSES\""              echo "  \"$ADDRESSES\""
1366              echo              echo
1367                test -f $DRESULTS".tar"  &&  rm -f $DRESULTS".tar"
1368                test -f $DRESULTS".tar.gz"  &&  rm -f $DRESULTS".tar.gz"
1369          fi          fi
         test -f $DRESULTS".tar"  &&  rm -f $DRESULTS".tar"  
         test -f $DRESULTS".tar.gz"  &&  rm -f $DRESULTS".tar.gz"  
1370      fi      fi
1371  fi  fi
1372    

Legend:
Removed from v.1.103  
changed lines
  Added in v.1.132

  ViewVC Help
Powered by ViewVC 1.1.22